package com.nisum.poc.facade;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.client.loadbalancer.LoadBalanced;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.Bean;
import org.springframework.web.reactive.function.client.WebClient;

@SpringBootApplication
@EnableEurekaClient
public class EmployeeServiceFacadeApplication {

	public static void main(String[] args) {
		SpringApplication.run(EmployeeServiceFacadeApplication.class, args);
	}

	@Bean(value = "empWebClient")
	@LoadBalanced
	public WebClient.Builder getEmpWebClient(){
		return WebClient.builder().baseUrl("lb://employee-ws/employee/");
	}

	@Bean(value = "departmentWebClient")
	@LoadBalanced
	public WebClient.Builder getDepWebClient(){
		return WebClient.builder().baseUrl("lb://department-ws/department/");
	}

	@Bean(value = "projectWebClient")
	@LoadBalanced
	public WebClient.Builder getProjWebClient(){
		return WebClient.builder().baseUrl("lb://project-ws/project/");
	}

}
