package com.nisum.poc.facade.client.impl;

import com.nisum.poc.facade.client.IDepartmentClient;
import com.nisum.poc.facade.response.DepartmentDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Mono;

import java.time.temporal.ChronoUnit;
import java.util.concurrent.TimeUnit;

@Repository
public class DepartmentClient implements IDepartmentClient {


    private final WebClient.Builder departmentWebClient;

    @Autowired
    public DepartmentClient(@Qualifier("departmentWebClient") WebClient.Builder departmentWebClient) {
        this.departmentWebClient = departmentWebClient;
    }

    @Override
    public Mono<DepartmentDetails> fetchDepartmentById(Long departmentId) {

        try {
            TimeUnit.SECONDS.sleep(30l);
        }catch (Exception e){

        }
        return departmentWebClient.build().get()
                .uri(uriBuilder -> uriBuilder.path("/v1/find/{departmentId}").build(departmentId))
                .retrieve().bodyToMono(DepartmentDetails.class);


    }
}
