package com.nisum.poc.facade.client.impl;

import com.nisum.poc.facade.client.IProjectClient;
import com.nisum.poc.facade.response.EmployeeDetails;
import com.nisum.poc.facade.response.ProjectDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Mono;

import java.time.temporal.ChronoUnit;
import java.util.concurrent.TimeUnit;

@Repository
public class ProjectClient implements IProjectClient {

    private WebClient.Builder projectWebClient;

    @Autowired
    public ProjectClient(@Qualifier("projectWebClient") WebClient.Builder projectWebClient) {
        this.projectWebClient = projectWebClient;
    }
    @Override
    public Mono<ProjectDetails> findProjectDetails(Long projectId) {

        try {
            TimeUnit.SECONDS.sleep(10l);
        }catch (Exception e){

        }
        return projectWebClient.build().get()
                .uri(uriBuilder -> uriBuilder.path("/v1/find/{projectId}").build(projectId))
                .retrieve().bodyToMono(ProjectDetails.class);
    }
}
