package com.nisum.poc.facade.controller;

import com.nisum.poc.facade.response.EmployeeDetails;
import com.nisum.poc.facade.response.EmployeeFacadeResponse;
import com.nisum.poc.facade.service.IEmployeeService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping(value = "/facade")
public class EmployeeFacadeController {

    Logger logger = LoggerFactory.getLogger(EmployeeFacadeController.class);
    private final IEmployeeService employeeService;

    @Autowired
    public EmployeeFacadeController(IEmployeeService employeeService){
        this.employeeService = employeeService;
    }

    @GetMapping(value = "/v1/all/employee")
    public Flux<EmployeeDetails> fetchAllEmployee(){

        logger.info("Calling All Employee API Controller ...");
        return employeeService.fetchEmployeeDetails();
    }

    /**
     *
     * @param empId
     * @return
     */
    @GetMapping(value = "/v1/{empId}/employee")
    public Mono<EmployeeFacadeResponse> fetchEmployeeById(@PathVariable Long empId){

        logger.info("Calling Particular Employee API Controller : {}", empId);
        return employeeService.fetchEmployeeById(empId);
    }
}
